/*
 *	@(#) init.h 2.2 88/05/18 
 *
 *	Copyright (C) The Santa Cruz Operation, 1984, 1985, 1986, 1987.
 *	Copyright (C) Microsoft Corporation, 1984, 1985, 1986, 1987.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 */

extern int clkstart(),cinit(),binit(),errinit(),iinit(),inoinit(), clkinit();
extern int strinit();
#ifdef X25_0
extern x25init();
#endif
#ifdef BX25S_0
extern bxncinit();
extern sessinit();
#endif
#ifdef ST_0
extern	stinit();
#endif
#ifdef	VPM_0
extern	vpminit();
#endif
#ifdef EM_0
extern  eminit();
#endif

/*	Array containing the addresses of the various initializing	*/
/*	routines executed by "main" at boot time.			*/
/*	Note that dfinit must be called after open(swapdev) done in iinit() */

int (*init_tbl[])() = {
	clkinit,
	cinit,
	binit,
#ifdef ERR
	errinit,
#endif
	iinit,
	strinit,
#ifdef	VPM_0
	vpminit,
#endif
#ifdef X25_0
	x25init,
#endif
#ifdef ST_0
	stinit,
#endif
#ifdef BX25S_0
        bxncinit,
        sessinit,
#endif
#ifdef EM_0
	eminit,
#endif
	meminit,	/* all calls to memget must precede this call */
			/* all calls to mfalloc must follow this call */
	dfinit,
	0
};
