/*
 *	@(#) select.h 1.1 88/05/18 
 *
 *	Copyright (C) The Santa Cruz Operation, 1988.
 *	Copyright (C) Microsoft Corporation, 1988.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS DESIGNED TO BE
 * PORTABLE BETWEEN DIFFERENT MACHINE ARCHITECTURES
 * AND CONFIGURATIONS. IT SHOULD NOT REQUIRE ANY
 * MODIFICATIONS WHEN ADAPTING XENIX TO NEW HARDWARE.
 */

/*
 * Code used internally for select system call.
 */
#define IOC_SELECT	0xffff

/*
 * Selectable conditions for select system call
 */
#define	SELREAD		0x1
#define	SELWRITE	0x2
#define	SELEXCEPT	0x4

/*
 * Structure used to specify timeout in select(2) system call.
 */
struct timeval {
	long	tv_sec;		/* seconds */
	long	tv_usec;	/* and microseconds */
};
