/*
 *	@(#) shm.h 2.2 88/05/18 
 *
 *	Copyright (C) The Santa Cruz Operation, 1984, 1985, 1986, 1987, 1988.
 *	Copyright (C) Microsoft Corporation, 1984, 1985, 1986, 1987, 1988.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS DESIGNED TO BE
 * PORTABLE BETWEEN DIFFERENT MACHINE ARCHITECTURES
 * AND CONFIGURATIONS. IT SHOULD NOT REQUIRE ANY
 * MODIFICATIONS WHEN ADAPTING XENIX TO NEW HARDWARE.
 */


/* System V defines */
#define SHM_RDONLY	010000	 /* attach read-only, else read-write */
#define SHM_RND		020000

/* shm segs start at addr given by (addr - (addr % SHMLBA)) */
#ifdef M_I386
#define SHMLBA		0x400000
#else
#define SHMLBA		0x10000
#endif

/* shmctl cmds:  NOT YET IMPLEMENTED -- EINVAL IF USED */
#define SHM_LOCK	3
#define SHM_UNLOCK	4

struct	shmid_ds {
	struct	ipc_perm shm_perm;	/* operation permission struct */
	int	shm_segsz;		/* segment size */
	ushort	shm_ptbl;		/* addr of sd segment */
	ushort	shm_lpid;		/* pid of last shared mem op */
	ushort	shm_cpid;		/* creator pid */
	ushort	shm_nattch;		/* current # attached */
	ushort	shm_cnattch;		/* in-core # attached */
	time_t	shm_atime;		/* last attach time */
	time_t	shm_dtime;		/* last detach time */
	time_t	shm_ctime;		/* last change time */
};		

#ifdef M_I386
extern	char	*shmat();
#else
extern	char far *shmat();
#endif
