/*
 *	@(#) var.h 2.4 88/07/13 
 *
 *	Copyright (C) The Santa Cruz Operation, 1984, 1985, 1986, 1987, 1988.
 *	Copyright (C) Microsoft Corporation, 1984, 1985, 1986, 1987, 1988.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS DESIGNED TO BE
 * PORTABLE BETWEEN DIFFERENT MACHINE ARCHITECTURES
 * AND CONFIGURATIONS. IT SHOULD NOT REQUIRE ANY
 * MODIFICATIONS WHEN ADAPTING XENIX TO NEW HARDWARE.
 */

struct var {
	int v_buf;              /* NBUF			*/
	int v_sabuf;            /* NSABUF               */
	int v_hbuf;             /* NHBUF                */
	int v_hmask;            /* NHBUF-1              */
	int v_maxbuf;		/* MAXBUF		*/
	int v_call;             /* NCALL		*/
	int v_inode;            /* NINODE		*/
	inodep_t ve_inode;	/*   &inode[NINODE]	*/
	int v_file;             /* NFILE		*/
	filep_t ve_file;	/*   &file[NFILE]  	*/
	int v_mount;            /* NMOUNT		*/
	struct mount *ve_mount; /*   &mount[NMOUNT]	*/
	int v_proc;             /* NPROC		*/
	struct proc *ve_proc;   /*   &proc[NPROC]	*/
#ifndef M_I386
	int v_text;             /* NTEXT		*/
	struct text *ve_text;   /*   &text[NTEXT]	*/
#endif
	int v_clist;            /* NCLIST		*/
	int v_maxup;            /* MAXUPRC		*/
	int v_maxmem;           /* MAXMEM		*/
	int v_lock;             /* NFLOCKS		*/
	int v_sdata;            /* NSDSEGS		*/
	int v_sdslots;		/* NSDSLOTS		*/
	int v_msgmap;		/* MSGMAP		*/
	int v_msgmax;		/* MSGMAX		*/
	int v_msgmnb;		/* MSGMNB  		*/
	int v_msgmni;		/* MSGMNI		*/
	int v_msgtql;		/* MSGTQL		*/
	int v_msgssz;		/* MSGSSZ		*/
	unsigned short v_msgseg;/* MSGSEG		*/
	int v_semmap;		/* SEMMAP		*/
	int v_semmni;		/* SEMMNI		*/
	int v_semmnu;		/* SEMMNU		*/
	int v_semmsl;		/* SEMMSL		*/
	int v_semopm;		/* SEMOPM		*/
	int v_semume;		/* SEMUME		*/
	int v_semvmx;		/* SEMVMX		*/
	int v_semaem;		/* SEMAEM		*/
	int v_semmns;		/* SEMMNS		*/
	int v_semusz;		/* SEMUSZ		*/
	int v_scrn;		/* NSCRN		*/
	int v_pbuf;		/* NPBUF		*/
	int v_emap;		/* NEMAP		*/
	int v_sxt;		/* NSXT			*/

	int v_shmmax;		/* SHMMAX		*/
	int v_shmmin;		/* SHMMIN		*/
	int v_shmmni;		/* SHMMNI		*/
	int v_shmseg;		/* SHMSEG		*/
	int v_shmbrk;		/* SHMBRK		*/
	int v_shmall;		/* SHMALL		*/
	int v_nsdtab;		/* # entries in sdtab[] */

	int v_nqueue;		/* Nbr of streams queues.		*/
	int v_nstream;		/* Number of stream head structures.	*/
	int v_nblk8192;		/* Number of 8192 byte stream buffers.	*/
	int v_nblk4096;		/* Number of 4096 byte stream buffers.	*/
	int v_nblk2048;		/* Number of 2048 byte stream buffers.	*/
	int v_nblk1024;		/* Number of 1024 byte stream buffers.	*/
	int v_nblk512;		/* Number of 512 byte stream buffers.	*/
	int v_nblk256;		/* Number of 256 byte stream buffers.	*/
	int v_nblk128;		/* Number of 128 byte stream buffers.	*/
	int v_nblk64;		/* Number of 64 byte stream buffers.	*/
	int v_nblk32;		/* Number of 32 byte stream buffers.	*/
	int v_nblk16;		/* Number of 16 byte stream buffers.	*/
	int v_nblk4;		/* Number of 4 byte stream buffers.	*/

	int v_disk;		/* NDISK				*/

	int v_evqueues;		/* Number of event queues 		*/
	int v_evdevs;		/* Number of event devs 		*/
	int v_evdevsperq;	/* Max event devices per event queue    */

	int v_scrnmem;		/* SCRNMEM				*/
	int v_kbtype;		/* Keyboard type where XT==0 and AT==1  */
};
extern struct var v;
