/*
 *	@(#) xmap.h 1.1 88/05/18 
 *
 *	Copyright (C) The Santa Cruz Operation, 1988.
 *	Copyright (C) Microsoft Corporation, 1988.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 */

/*
 *	xmap structure - provides a per-tty structure for recording
 *	state information by emap and nmap routines.  Also used by
 *	select to avoid cluttering up tty structure.
 */

struct xmap {
	/*
	 *	select fields
	 */
	struct proc *	xm_selrd;	/* Process waiting on selwait (read) */
	struct proc *	xm_selwr;	/* Process waiting on selwait (write)*/
	/*
 	 *	emap fields (used to be in tty structure)
	 */
	struct emap *	xm_emp;		/* emapping table */
	unsigned char	xm_emchar;	/* saved emapping char */
	unsigned char	xm_emonmap;	/* True if should call nmmapout */
	/*
	 *	nmap fields
	 */
	struct nmap *	xm_nmp;		/* nmapping table */
#if	defined(M_I086) || defined(M_I186) || defined(M_I286)
	char far *	xm_nmiseqp;	/* Current pos in lead-in (input) */
	char far *	xm_nmoseqp;	/* Current pos in lead-in (output) */
#else
	char *		xm_nmiseqp;	/* Current pos in lead-in (input) */
	char *		xm_nmoseqp;	/* Current pos in lead-in (output) */
#endif
	unsigned short	xm_nmincnt;	/* # chars left in trailer (input) */
	unsigned short	xm_nmoncnt;	/* # chars left in trailer (output) */
	unsigned char	xm_nmiseqn;	/* Index of current lead-in (input) */
	unsigned char	xm_nmoseqn;	/* Index of current lead-in (output) */
};
